## aften 0.0.8svn20100103

=== CMakeLists.txt ===
--- 
+++ 
@@ -59,19 +59,19 @@
                   libaften/util.c
                   libaften/convert.c)
 
-SET(LIBAFTEN_X86_SRCS libaften/x86/x86_cpu_caps.c)
-
-SET(LIBAFTEN_X86_MMX_SRCS libaften/x86/x86_mmx_exponent.c)
-
-SET(LIBAFTEN_X86_SSE_SRCS libaften/x86/x86_sse_mdct_dummy.c
-                          libaften/x86/x86_sse_mdct_common_init.c
-                          libaften/x86/x86_sse_window.c)
-
-SET(LIBAFTEN_X86_SSE2_SRCS libaften/x86/x86_sse2_exponent.c)
-
-SET(LIBAFTEN_X86_SSE3_SRCS libaften/x86/x86_sse3_mdct_dummy.c)
-
-SET(LIBAFTEN_PPC_SRCS libaften/ppc/ppc_cpu_caps.c)
+SET(LIBAFTEN_X86_SRCS libaften/x86/cpu_caps.c)
+
+SET(LIBAFTEN_X86_MMX_SRCS libaften/x86/exponent_mmx.c)
+
+SET(LIBAFTEN_X86_SSE_SRCS libaften/x86/mdct_sse.c
+                          libaften/x86/mdct_common_sse.c
+                          libaften/x86/window_sse.c)
+
+SET(LIBAFTEN_X86_SSE2_SRCS libaften/x86/exponent_sse2.c)
+
+SET(LIBAFTEN_X86_SSE3_SRCS libaften/x86/mdct_sse3.c)
+
+SET(LIBAFTEN_PPC_SRCS libaften/ppc/cpu_caps.c)
 SET(LIBAFTEN_ALTIVEC_SRCS libaften/ppc/mdct_altivec.c)
 
 SET(AFTEN_SRCS aften/aften.c aften/opts.c)
@@ -122,9 +122,8 @@
 ENDIF(CMAKE_COMPILER_IS_GNUCC)
 
 IF(CMAKE_COMPILER_IS_ICC)
-  # icc ignores bogus options, so detection makes no sense
   SET(CMAKE_C_FLAGS_RELEASE "-O3 -funroll-loops -fomit-frame-pointer ${CMAKE_C_FLAGS_RELEASE}")
-  SET(ADD_CFLAGS "-std=c99 -Wall ${ADD_CFLAGS}")
+  SET(ADD_CFLAGS "-std=c99 -Wall -wd810 ${ADD_CFLAGS}")
 ENDIF(CMAKE_COMPILER_IS_ICC)
 
 IF(MSVC)
@@ -187,6 +186,8 @@
   ADD_DEFINE("SVN_VERSION \"${SVN_VERSION}\"")
 ENDIF(SVN_VERSION)
 
+CHECK_POSIX_MEMALIGN()
+
 # do SIMD stuff
 IF(CMAKE_SYSTEM_MACHINE MATCHES "i.86" OR CMAKE_SYSTEM_MACHINE MATCHES "x86_64")
   CHECK_MMX()
@@ -212,11 +213,6 @@
       ENDFOREACH(SRC)
       ENDIF(NOT DOUBLE)
       ADD_DEFINE(HAVE_SSE)
-
-      CHECK_MM_MALLOC()
-      IF(NOT HAVE_MM_MALLOC)
-        CHECK_POSIX_MEMALIGN()
-      ENDIF(NOT HAVE_MM_MALLOC)
     ENDIF(HAVE_SSE)
 
     IF(HAVE_SSE2)
@@ -334,3 +330,9 @@
   ENDIF(CSCOMPILER MATCHES "NOTFOUND")
   ADD_CUSTOM_COMMAND(
     OUTPUT ${AFTENSHARP_DLL}
+    COMMAND ${CSCOMPILER} -t:library -out:${AFTENSHARP_DLL} -o+ ${AFTENSHARP_SRCS}
+    DEPENDS ${AFTENSHARP_SRCS}
+    WORKING_DIRECTORY ${Aften_SOURCE_DIR})
+  ADD_CUSTOM_TARGET(
+    AftenSharp
+    ALL
