=== debian/changelog ===
aften (0.0.8svn20100103-dmo4) unstable; urgency=medium

  * Fix build with cmake 4

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 19 Jan 2026 09:46:37 +0100

aften (0.0.8svn20100103-dmo3+b1) unstable; urgency=medium

  * Rebuild for PAC/BTI support; no source changes.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 31 Oct 2024 07:38:25 +0100

aften (0.0.8svn20100103-dmo3) unstable; urgency=medium

  * Change debian source format to '3.0 (quilt)

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 28 Nov 2017 16:54:20 +0100

aften (0.0.8svn20100103-dmo2) unstable; urgency=medium

  * Don't install /usr/bin/wavinfo already in wavbreaker package.
  * Rebuild with PIE

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 12 Mar 2017 08:43:13 +0100

aften (0.0.8svn20100103-dmo1) unstable; urgency=low

  * Update debian version number to dmo1.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 18 Jun 2012 14:20:59 +0200

aften (0.0.8svn20100103-0.2) unstable; urgency=low

  * Fix the build for powerpc.

 -- Christian Marillat <marillat@debian.org>  Tue, 03 Apr 2012 22:28:44 +0200

aften (0.0.8svn20100103-0.1) unstable; urgency=low

  * Move to debhelper 9 for multi-arch and hardened build flags.

 -- Christian Marillat <marillat@debian.org>  Tue, 03 Apr 2012 10:51:02 +0200

aften (0.0.8svn20100103-0.0) unstable; urgency=low

  * SVN release to fix powerpc build.

 -- Christian Marillat <marillat@debian.org>  Sun, 03 Jan 2010 10:12:12 +0100

aften (0.0.8svn20080925-0.1) unstable; urgency=low

  * Don't package waveinfo already in wavbreaker and useless in aften.

 -- Christian Marillat <marillat@debian.org>  Sat, 02 Jan 2010 17:59:13 +0100

aften (0.0.8svn20080925-0.0) unstable; urgency=low

  * SVN release to fix build for arch other than X86.
  * Build shared library.
  * Disable altivec for powerpc.

 -- Christian Marillat <marillat@debian.org>  Fri, 17 Oct 2008 16:52:04 +0200

aften (0.0.8-0.1) unstable; urgency=low

  * Remove libaften0 package (shared library doesn't build for all arches
    except for i386 and amd64).

 -- Christian Marillat <marillat@debian.org>  Mon, 25 Aug 2008 12:46:52 +0200

aften (0.0.8-0.0) unstable; urgency=low

  * Initial release.

 -- Christian Marillat <marillat@debian.org>  Mon, 25 Aug 2008 12:07:26 +0200
