=== debian/control ===
Source: aften
Section: sound
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Standards-Version: 4.7.3
Homepage: https://aften.sourceforge.net/
Build-Depends: debhelper-compat (= 13), cmake, ninja-build, quilt

Package: aften
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: audio AC3 encoder
 Aften is an audio encoder which generates compressed audio streams based on
 ATSC A/52 specification. This type of audio is also known as AC-3 or Dolby®
 Digital and is one of the audio codecs used in DVD-Video content.

Package: libaften0
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: audio AC3 encoder - runtime files
 Aften is an audio encoder which generates compressed audio streams based on
 ATSC A/52 specification. This type of audio is also known as AC-3 or Dolby®
 Digital and is one of the audio codecs used in DVD-Video content.

Package: libaften-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libaften0 (= ${binary:Version}), ${misc:Depends}
Description: audio AC3 encoder - development files
 Aften is an audio encoder which generates compressed audio streams based on
 ATSC A/52 specification. This type of audio is also known as AC-3 or Dolby®
 Digital and is one of the audio codecs used in DVD-Video content.
