=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Bbuild -Scmake+ninja --with quilt

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DCMAKE_INSTALL_LIBDIR=$(DEB_HOST_MULTIARCH) \
	-DSHARED=yes

ifeq "$(DEB_BUILD_ARCH)" "powerpc"
	perl -i -pe 's,HAVE_ALTIVEC:INTERNAL=1,HAVE_ALTIVEC:INTERNAL=0,' build/CMakeCache.txt
endif

override_dh_auto_test:
