=== debian/watch ===
version=4

#opts=uversionmangle=s/0.0/0.0./ \
#https://sf.net/aften/aften-(.*)@ARCHIVE_EXT@
