## aften 0.0.8+git20100105

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,9 @@
 # CMake project file by Prakash Punnoor
 CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
+
+IF(COMMAND cmake_policy)
+  cmake_policy(SET CMP0003 NEW)
+ENDIF(COMMAND cmake_policy)
 
 IF(NOT DEFINED CMAKE_BUILD_TYPE)
   SET(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel.")
@@ -45,44 +49,91 @@
 INCLUDE_DIRECTORIES(${Aften_SOURCE_DIR}/aften)
 INCLUDE_DIRECTORIES(${Aften_SOURCE_DIR}/pcm)
 
-SET(LIBAFTEN_SRCS libaften/a52enc.c
+SET(LIBAFTEN_SRCS libaften/a52enc.h
+                  libaften/a52enc.c
+                  libaften/a52.h
                   libaften/a52.c
+                  libaften/a52tab.h
                   libaften/a52tab.c
+                  libaften/bitalloc.h
                   libaften/bitalloc.c
+                  libaften/bitio.h
                   libaften/bitio.c
+                  libaften/crc.h
                   libaften/crc.c
+                  libaften/dynrng.h
                   libaften/dynrng.c
+                  libaften/window.h
                   libaften/window.c
+                  libaften/mdct.h
                   libaften/mdct.c
+                  libaften/exponent.h
                   libaften/exponent.c
+                  libaften/filter.h
                   libaften/filter.c
                   libaften/util.c
-                  libaften/convert.c)
-
-SET(LIBAFTEN_X86_SRCS libaften/x86/cpu_caps.c)
-
-SET(LIBAFTEN_X86_MMX_SRCS libaften/x86/exponent_mmx.c)
+                  libaften/convert.h
+                  libaften/convert.c
+                  libaften/threading.h
+                  libaften/a52dec.h
+                  libaften/aften.h
+                  libaften/aften-types.h
+                  libaften/cpu_caps.h
+                  libaften/mem.h
+                  common.h
+                  bswap.h)
+
+SET(LIBAFTEN_X86_SRCS libaften/x86/cpu_caps.c
+                      libaften/x86/cpu_caps.h
+                      libaften/x86/asm_common.h
+                      libaften/x86/asm_support.h
+                      libaften/x86/gas_support.h
+                      libaften/x86/intelas_support.h)
+
+SET(LIBAFTEN_X86_MMX_SRCS libaften/x86/exponent_mmx.c
+                          libaften/x86/exponent.h
+                          libaften/x86/simd_support.h)
 
 SET(LIBAFTEN_X86_SSE_SRCS libaften/x86/mdct_sse.c
                           libaften/x86/mdct_common_sse.c
-                          libaften/x86/window_sse.c)
-
-SET(LIBAFTEN_X86_SSE2_SRCS libaften/x86/exponent_sse2.c)
-
-SET(LIBAFTEN_X86_SSE3_SRCS libaften/x86/mdct_sse3.c)
-
-SET(LIBAFTEN_PPC_SRCS libaften/ppc/cpu_caps.c)
-SET(LIBAFTEN_ALTIVEC_SRCS libaften/ppc/mdct_altivec.c)
-
-SET(AFTEN_SRCS aften/aften.c aften/opts.c)
+                          libaften/x86/mdct_common_sse.h
+                          libaften/x86/mdct.h
+                          libaften/x86/window_sse.c
+                          libaften/x86/window.h
+                          libaften/x86/simd_support.h)
+
+SET(LIBAFTEN_X86_SSE2_SRCS libaften/x86/exponent_sse2.c
+                           libaften/x86/exponent.h
+                           libaften/x86/simd_support.h)
+
+SET(LIBAFTEN_X86_SSE3_SRCS libaften/x86/mdct_sse3.c
+                           libaften/x86/mdct_common_sse.h
+                           libaften/x86/mdct.h
+                           libaften/x86/simd_support.h)
+
+SET(LIBAFTEN_PPC_SRCS libaften/ppc/cpu_caps.c
+                      libaften/ppc/cpu_caps.h)
+
+SET(LIBAFTEN_ALTIVEC_SRCS libaften/ppc/mdct_altivec.c
+                          libaften/ppc/mdct.h
+                          libaften/ppc/altivec_common.h)
+
+SET(AFTEN_SRCS aften/aften.c
+               aften/opts.c
+               aften/opts.h
+               aften/helptext.h)
 
 SET(PCM_SRCS pcm/aiff.c
              pcm/byteio.c
+             pcm/byteio.h
              pcm/caff.c
              pcm/convert.c
              pcm/formats.c
+             pcm/formats.h
              pcm/pcm.c
+             pcm/pcm.h
              pcm/pcmfile.c
+             pcm/pcmfile.h
              pcm/pcm_io.c
              pcm/raw.c
              pcm/wav.c)
@@ -91,11 +142,15 @@
 IF(CMAKE_UNAME)
   EXEC_PROGRAM(uname ARGS -m OUTPUT_VARIABLE CMAKE_SYSTEM_MACHINE)
 ELSE(CMAKE_UNAME)
-  MESSAGE("Could not detect machine type")
-  IF(CMAKE_SYSTEM MATCHES "Windows")
-    MESSAGE(STATUS "Assuming i386 machine")
-    SET(CMAKE_SYSTEM_MACHINE i386)
-  ENDIF(CMAKE_SYSTEM MATCHES "Windows")
+  IF(CMAKE_SYSTEM MATCHES "Windows" AND CMAKE_SYSTEM_PROCESSOR MATCHES "x86")
+	IF(CMAKE_SIZEOF_VOID_P MATCHES "8")
+      SET(CMAKE_SYSTEM_MACHINE "x86_64")
+	ELSE(CMAKE_SIZEOF_VOID_P MATCHES "8")
+      SET(CMAKE_SYSTEM_MACHINE "i386")
+	ENDIF(CMAKE_SIZEOF_VOID_P MATCHES "8")
+  ELSE(CMAKE_SYSTEM MATCHES "Windows" AND CMAKE_SYSTEM_PROCESSOR MATCHES "x86")
+	MESSAGE(FATAL_ERROR "Could not detect machine type")
+  ENDIF(CMAKE_SYSTEM MATCHES "Windows" AND CMAKE_SYSTEM_PROCESSOR MATCHES "x86")
 ENDIF(CMAKE_UNAME)
 
 DETECT_COMPILER()
@@ -176,66 +231,70 @@
 CHECK_INCLUDE_FILE_DEFINE(inttypes.h HAVE_INTTYPES_H)
 CHECK_INCLUDE_FILE_DEFINE(byteswap.h HAVE_BYTESWAP_H)
 
-# output SVN version to config.h
-EXECUTE_PROCESS(COMMAND svn info --xml WORKING_DIRECTORY ${Aften_SOURCE_DIR}
-OUTPUT_VARIABLE SVN_INFO ERROR_QUIET)
-STRING(REGEX MATCH "<entry[^>]+" SVN_VERSION "${SVN_INFO}")
-STRING(REGEX MATCH "revision=\"[0123456789]+\"" SVN_VERSION "${SVN_VERSION}")
-STRING(REGEX MATCH "[0123456789]+" SVN_VERSION "${SVN_VERSION}")
-IF(SVN_VERSION)
-  ADD_DEFINE("SVN_VERSION \"${SVN_VERSION}\"")
-ENDIF(SVN_VERSION)
+# output GIT version to config.h
+EXECUTE_PROCESS(COMMAND git log -1 --pretty=format:%h
+OUTPUT_VARIABLE GIT_VERSION ERROR_QUIET)
+IF(GIT_VERSION)
+  ADD_DEFINE("GIT_VERSION \"${GIT_VERSION}\"")
+ENDIF(GIT_VERSION)
 
 CHECK_POSIX_MEMALIGN()
 
 # do SIMD stuff
 IF(CMAKE_SYSTEM_MACHINE MATCHES "i.86" OR CMAKE_SYSTEM_MACHINE MATCHES "x86_64")
   CHECK_MMX()
-
-  IF(HAVE_MMX)
+  # MSVC doesn't have MMX support in x64 mode, so check for SSE independently
+  CHECK_SSE()
+  
+  IF(HAVE_MMX OR HAVE_SSE)
     INCLUDE_DIRECTORIES(${Aften_SOURCE_DIR}/libaften/x86)
     SET(LIBAFTEN_SRCS ${LIBAFTEN_SRCS} ${LIBAFTEN_X86_SRCS})
     ADD_DEFINE(HAVE_CPU_CAPS_DETECTION)
-
-    CHECK_SSE()
+  ENDIF(HAVE_MMX OR HAVE_SSE)
+  
+  IF(HAVE_MMX)
     SET(LIBAFTEN_SRCS ${LIBAFTEN_SRCS} ${LIBAFTEN_X86_MMX_SRCS})
+      SET(SIMD_FLAGS "${SIMD_FLAGS} ${MMX_FLAGS} -DUSE_MMX")
       FOREACH(SRC ${LIBAFTEN_X86_MMX_SRCS})
-        SET_SOURCE_FILES_PROPERTIES(${SRC} PROPERTIES COMPILE_FLAGS "${MMX_FLAGS} -DUSE_MMX")
+        SET_SOURCE_FILES_PROPERTIES(${SRC} PROPERTIES COMPILE_FLAGS ${SIMD_FLAGS})
       ENDFOREACH(SRC)
     ADD_DEFINE(HAVE_MMX)
-
-    IF(HAVE_SSE)
-      CHECK_SSE2()
-      IF(NOT DOUBLE)
+  ENDIF(HAVE_MMX)
+
+  IF(HAVE_SSE)
+    SET(SIMD_FLAGS "${SIMD_FLAGS} ${SSE_FLAGS} -DUSE_SSE")
+    IF(NOT DOUBLE)
       SET(LIBAFTEN_SRCS ${LIBAFTEN_SRCS} ${LIBAFTEN_X86_SSE_SRCS})
       FOREACH(SRC ${LIBAFTEN_X86_SSE_SRCS})
-        SET_SOURCE_FILES_PROPERTIES(${SRC} PROPERTIES COMPILE_FLAGS "${SSE_FLAGS} -DUSE_MMX -DUSE_SSE")
+        SET_SOURCE_FILES_PROPERTIES(${SRC} PROPERTIES COMPILE_FLAGS ${SIMD_FLAGS})
       ENDFOREACH(SRC)
-      ENDIF(NOT DOUBLE)
-      ADD_DEFINE(HAVE_SSE)
-    ENDIF(HAVE_SSE)
-
+    ENDIF(NOT DOUBLE)
+    ADD_DEFINE(HAVE_SSE)
+
+    CHECK_SSE2()
     IF(HAVE_SSE2)
-      CHECK_SSE3()
+      SET(SIMD_FLAGS "${SIMD_FLAGS} ${SSE2_FLAGS} -DUSE_SSE2")
       SET(LIBAFTEN_SRCS ${LIBAFTEN_SRCS} ${LIBAFTEN_X86_SSE2_SRCS})
       FOREACH(SRC ${LIBAFTEN_X86_SSE2_SRCS})
-        SET_SOURCE_FILES_PROPERTIES(${SRC} PROPERTIES COMPILE_FLAGS "${SSE2_FLAGS} -DUSE_MMX -DUSE_SSE -DUSE_SSE2")
+        SET_SOURCE_FILES_PROPERTIES(${SRC} PROPERTIES COMPILE_FLAGS ${SIMD_FLAGS})
       ENDFOREACH(SRC)
       ADD_DEFINE(HAVE_SSE2)
+
+      CHECK_SSE3()
+      IF(HAVE_SSE3)
+        SET(SIMD_FLAGS "${SIMD_FLAGS} ${SSE3_FLAGS} -DUSE_SSE3")
+        IF(NOT DOUBLE)
+          SET(LIBAFTEN_SRCS ${LIBAFTEN_SRCS} ${LIBAFTEN_X86_SSE3_SRCS})
+          FOREACH(SRC ${LIBAFTEN_X86_SSE3_SRCS})
+            SET_SOURCE_FILES_PROPERTIES(${SRC} PROPERTIES COMPILE_FLAGS ${SIMD_FLAGS})
+          ENDFOREACH(SRC)
+        ENDIF(NOT DOUBLE)
+        ADD_DEFINE(HAVE_SSE3)
+
+        CHECK_CASTSI128()
+      ENDIF(HAVE_SSE3)
     ENDIF(HAVE_SSE2)
-
-    IF(HAVE_SSE3)
-      IF(NOT DOUBLE)
-      SET(LIBAFTEN_SRCS ${LIBAFTEN_SRCS} ${LIBAFTEN_X86_SSE3_SRCS})
-      FOREACH(SRC ${LIBAFTEN_X86_SSE3_SRCS})
-        SET_SOURCE_FILES_PROPERTIES(${SRC} PROPERTIES COMPILE_FLAGS "${SSE3_FLAGS} -DUSE_MMX -DUSE_SSE -DUSE_SSE2 -DUSE_SSE3")
-      ENDFOREACH(SRC)
-      ENDIF(NOT DOUBLE)
-      ADD_DEFINE(HAVE_SSE3)
-
-      CHECK_CASTSI128()
-    ENDIF(HAVE_SSE3)
-  ENDIF(HAVE_MMX)
+  ENDIF(HAVE_SSE)
 ENDIF(CMAKE_SYSTEM_MACHINE MATCHES "i.86" OR CMAKE_SYSTEM_MACHINE MATCHES "x86_64")
 
 IF(CMAKE_SYSTEM_MACHINE MATCHES "Power Macintosh" OR CMAKE_SYSTEM_MACHINE MATCHES "ppc")
@@ -280,59 +339,3 @@
 SET_TARGET_PROPERTIES(aften_exe PROPERTIES OUTPUT_NAME aften)
 SET_TARGET_PROPERTIES(aften_exe PROPERTIES LINKER_LANGUAGE C)
 IF(WIN32)
-  # When linking to static aften, dllimport mustn't be used
-  SET_TARGET_PROPERTIES(aften_exe PROPERTIES COMPILE_FLAGS -DAFTEN_BUILD_LIBRARY)
-ENDIF(WIN32)
-TARGET_LINK_LIBRARIES(aften_exe aften_pcm aften_static)
-
-ADD_EXECUTABLE(wavinfo util/wavinfo.c)
-TARGET_LINK_LIBRARIES(wavinfo aften_pcm)
-
-ADD_EXECUTABLE(wavrms util/wavrms.c)
-TARGET_LINK_LIBRARIES(wavrms aften_pcm ${LIBM})
-
-ADD_EXECUTABLE(wavfilter util/wavfilter.c libaften/filter.c)
-TARGET_LINK_LIBRARIES(wavfilter aften_pcm ${LIBM})
-
-IF(BINDINGS_CXX)
-  MESSAGE("## WARNING: The C++ bindings are only lightly tested. Feed-back appreciated. ##")
-  Project(Aften CXX)
-  SET(CMAKE_CXX_FLAGS_RELEASE "${ADD_CFLAGS} ${CMAKE_C_FLAGS_RELEASE}")
-  INCLUDE_DIRECTORIES(${Aften_SOURCE_DIR}/bindings)
-  ADD_LIBRARY(aftenxx SHARED bindings/aftenxx.cxx)
-  SET_TARGET_PROPERTIES(aftenxx PROPERTIES VERSION ${SO_VERSION} SOVERSION ${SO_MAJOR_VERSION})
-  SET_TARGET_PROPERTIES(aftenxx PROPERTIES LINKER_LANGUAGE CXX)
-  SET_TARGET_PROPERTIES(aftenxx PROPERTIES DEFINE_SYMBOL AFTENXX_BUILD_LIBRARY)
-  TARGET_LINK_LIBRARIES(aftenxx aften)
-  SET(INSTALL_TARGETS ${INSTALL_TARGETS} aftenxx)
-  SET(INSTALL_HEADERS ${INSTALL_HEADERS} bindings/aftenxx.h)
-ENDIF(BINDINGS_CXX)
-IF(BINDINGS_CS)
-  MESSAGE("## WARNING: The C# bindings are not completed, but tested (see \"API C#.txt\"). ##")
-  SET(AFTENSHARP_SRCS bindings/cs/AftenTypes.cs
-                      bindings/cs/FrameEncoder.cs
-                      bindings/cs/FrameEventArgs.cs
-                      bindings/cs/Utility.cs)
-  IF(WIN32)
-    SET(WIN_SRCS "")
-    FOREACH(SRC ${AFTENSHARP_SRCS})
-      STRING(REPLACE "/" "\\" WIN_SRC ${SRC})
-      SET(WIN_SRCS ${WIN_SRCS} ${WIN_SRC})
-    ENDFOREACH(SRC ${AFTENSHARP_SRCS})
-    SET(AFTENSHARP_SRCS ${WIN_SRCS})
-  ENDIF(WIN32)
-  SET(AFTENSHARP_DLL ${Aften_BINARY_DIR}/AftenSharp.dll)
-  FIND_PROGRAM(
-    CSCOMPILER
-    NAMES csc gmcs)
-  IF(CSCOMPILER MATCHES "NOTFOUND")
-    MESSAGE(SEND_ERROR "Could not locate a supported C# compiler")
-  ENDIF(CSCOMPILER MATCHES "NOTFOUND")
-  ADD_CUSTOM_COMMAND(
-    OUTPUT ${AFTENSHARP_DLL}
-    COMMAND ${CSCOMPILER} -t:library -out:${AFTENSHARP_DLL} -o+ ${AFTENSHARP_SRCS}
-    DEPENDS ${AFTENSHARP_SRCS}
-    WORKING_DIRECTORY ${Aften_SOURCE_DIR})
-  ADD_CUSTOM_TARGET(
-    AftenSharp
-    ALL
